LSTOPO(1)

NAME
lstopo - Show the topology of the system (note that hwloc-bind(1) provides a detailed explanation of the hwloc system; it should be read before reading this man page).

SYNOPSIS
lstopo [ options ]... [ filename ]

OPTIONS

-v --verbose
    Include additional detail.

-s --silent
    Opposite of --verbose (default).

-l --logical
    Display hwloc logical indexes instead of physical/OS indexes (default). These indexes are prefixed with "#". The physical indexes of some objects (PU and Node by default, all objects if verbose) will appear as object attribute "phys=...".

-p --physical
    Display OS/physical indexes instead of hwloc logical indexes. These indexes are prefixed with "p#" instead of "#".

-c --cpuset
    Display the cpuset of each object.

-C --cpuset-only
    Only display the cpuset of each object; do not display anything else about the object.

--only <type>
    Only show objects of the given type in the text output.

--ignore <type>
    Ignore all objects of type <type> in the topology.

--no-caches
    Do not show caches.

--no-useless-caches
    Do not show caches which do not have a hierarchical impact.

--whole-system
    Do not consider administration limitations.

--merge
    Do not show levels that do not have a hierarchical impact.

--xml <path>
    Read topology from XML file <path> (instead of discovering the topology on the local machine). If <path> is "-", the standard input is used. XML support must have been compiled in to hwloc for this option to be usable.

--fsys-root <path>
    Read topology from the chroot specified by <path> (instead of discovering the topology on the local machine). This option is generally only available on Linux.

--pid <pid>
    Detect topology as seen by process <pid>, i.e. as if process <pid> did the discovery itself, and show its current binding. Note that this can for instance change the set of allowed processors. If 0 is given as pid, the current binding for the lstopo process will be shown.

--top
    Show existing processes as misc objects in the output. To avoid uselessly cluttering the output, only processes that are restricted to some part of the machine are shown. On Linux, kernel threads are not shown.

--synthetic <specification>
    Simulate a fake hierarchy (instead of discovering the topology on the local machine).

--fontsize <size>
    Set size of text font.

--gridsize <size>
    Set size of margin between elements.

--horiz
    Horizontal graphic layout instead of nearly 4/3 ratio.

--vert
    Vertical graphic layout instead of nearly 4/3 ratio.

--version
    Report version and exit.

DESCRIPTION
lstopo is capable of displaying a topological map of the system in a variety of different output formats. If no filename is specified and the DISPLAY environment variable is set, lstopo displays the map in a graphical window. If no filename is specified and the DISPLAY environment variable is not set, a text summary is displayed.

The filename specified directly implies the output format that will be used; see the OUTPUT FORMATS section, below. Output formats that support color will indicate specific characteristics about individual CPUs by their color; see the COLORS section, below.

OUTPUT FORMATS

-   Send a text summary to stdout.

/dev/stdout
    Send a text summary to stdout. It is effectively the same as specifying "-".

<filename>.txt
    If the filename ends in ".txt", lstopo outputs an ASCII art representation of the map.

-.txt
    If the entire filename is "-.txt", lstopo outputs the same ASCII art representation as other ".txt" filenames, but with two execeptions: 1) the output is sent to stdout, and 2) if colors are supported on the terminal, the ASCII art will be colorized.

<filename>.fig
    If the filename ends in ".fig", lstopo outputs a representation of the map that can be loaded in Xfig.

<filename>.pdf
    If the filename ends in ".pdf" and lstopo was compiled with the proper support, lstopo outputs a PDF representation of the map.

<filename>.ps
    If the filename ends in ".ps" and lstopo was compiled with the proper support, lstopo outputs a Postscript representation of the map.

<filename>.png
    If the filename ends in ".png" and lstopo was compiled with the proper support, lstopo outputs a PNG representation of the map.

<filename>.svg
    If the filename ends in ".svn" and lstopo was compiled with the proper support, lstopo outputs an SVG representation of the map.

<filename>.xml
    If the filename ends in ".xml" and lstopo was compiled with the proper support, lstopo outputs an XML representation of the map.

See the output of "lstopo --help" for a specific list of what graphical output formats are supported in your hwloc installation.

COLORS
Individual CPUs are colored in the semi-graphical and graphical output formats to indicate different characteristics:

Green
    The CPU is in the current CPU binding mask.

White
    The CPU is in the allowed set (see below), but it is not in the current CPU binding mask.

Red The CPU is not in the allowed set (see below).

Black
    The CPU is offline (not all OS's support displaying offline CPUs).

The "allowed set" is the set of CPUs to which the current process is allowed to bind. The allowed set is usually either inherited from the parent process or set by administrative qpolicies on the system. Linux cpusets are one example of limiting the allowed set for a process and its children to be less than the full set of CPUs on the system.

Different processes may therefore have different CPUs in the allowed set. Hence, invoking lstopo in different contexts and/or as different users may display different colors for the same individual CPUs (e.g., running lstopo in one context may show a specific CPU as red, but running lstopo in a different context may show the same CPU as white).

LAYOUT
In its graphical output, lstopo uses simple rectangular heuristics to try to achieve a 4/3 ratio between width and height. However, in the particular case of NUMA nodes, the layout is always a flat rectangle, to avoid letting the user believe any particular NUMA topology (lstopo is not able to render that yet).

EXAMPLES
To display the machine topology in text mode:
    lstopo - To display in graphical mode (assuming that the DISPLAY environment variable is set to a relevant value):
    lstopo To export the topology to a PNG file:
    lstopo file.png To display a summary of the topology:
    lstopo -s To get more details about the topology:
    lstopo -v To only show cores:
    lstopo --only core To show cpusets:
    lstopo --cpuset To only show the cpusets of sockets:
    lstopo --only socket --cpuset-only Simulate a fake hierarchy; this example shows with 2 NUMA nodes of 2 processor units:
    lstopo --synthetic "n:2 2" To count the number of logical processors in the system
   lstopo --only pu | wc -l

SEE ALSO
hwloc-bind(1)